Set Implicit Arguments.
Generalizable All Variables.

Require Import Prelude.
Require Import Specification.

Module Type Context.

  Declare Module Spec : Specification.
  Import Spec.

  (*  _____            _                                      _    *)
  (* | ____|_ ____   _(_)_ __ ___  _ __  _ __ ___   ___ _ __ | |_  *)
  (* |  _| | '_ \ \ / / | '__/ _ \| '_ \| '_ ` _ \ / _ \ '_ \| __| *)
  (* | |___| | | \ V /| | | | (_) | | | | | | | | |  __/ | | | |_  *)
  (* |_____|_| |_|\_/ |_|_|  \___/|_| |_|_| |_| |_|\___|_| |_|\__| *)

  (* We model a single environment. *)

  (* namespaceEnv maps each namespace to the list of associated
     data. A typing environment for example maps term variables
     to types:
       namespaceEnv termVarNamespaces |-> cons typeSort nil
  *)

  Parameter namespaceEnv  : Namespace → list Sort.
  Parameter namespaceData : Namespace → list Sort.

End Context.
